
var PSForm = null;

var spriteAnimObj = null;
var spriteAnimStep = 0;
var spriteAnimTimer = null;

var copyAnimSeq[0];
var copyAnimPointer = 0;
var copyAnimObj = null;
var	copyAnimTimer = null;

var visibleAnimSeq[0];
var visibleAnimPointer = 0;
var	visibleAnimTimer = null;


function AnimTest() {

	var margin = 10;

	var spriteImage = Script. Path + "images\\banghead64x64.png";
	var frameImages = ["banghead64x64-1.png", "banghead64x64-2.png", "banghead64x64-3.png", "banghead64x64-4.png", "banghead64x64-5.png", "banghead64x64-6.png", "banghead64x64-7.png", "banghead64x64-8.png"];

    PSForm = new TForm(WeBuilder);
    PSForm.Width = 160;
    PSForm.Height = 400;
    PSForm.Position = poScreenCenter;
    PSForm.BorderStyle = bsSingle; 		// disable dialog resizing
    PSForm.BorderIcons = biSystemMenu; //remove maximize & minimize buttons
	PSForm.FormStyle = fsStayOnTop;
    PSForm.Color = clBtnFace;
	PSForm.PixelsPerInch = 120;
    PSForm.Caption = "AnimTest";

	var Label1 = new TLabel(WeBuilder);
	Label1.Parent = PSForm;
	Label1.Anchors = akLeft + akTop;
	Label1.Caption = "Image Sprite method";
	Label1.SetBounds(margin, margin, 150, 25);

	var ImagePanel1 = new TPanel(WeBuilder);
	ImagePanel1.Parent = PSForm;
	ImagePanel1.BevelInner = bvNone;
	ImagePanel1.BevelOuter = bvNone;
	ImagePanel1.SetBounds(margin, margin + Label1.Top + Label1.Height, 64, 64);

    var Image1 = new TImage(WeBuilder);
    Image1.Parent = ImagePanel1;
    Image1.Picture.LoadFromFile(spriteImage);
    Image1.Visible = true;
    Image1.Transparent = false;
	Image1.AutoSize = true;
    Image1.Left = 0;
	Image1.Top = 0;


	var Label2 = new TLabel(WeBuilder);
	Label2.Parent = PSForm;
	Label2.Anchors = akLeft + akTop;
	Label2.Caption = "Image Copy method";
	Label2.SetBounds(margin, margin + ImagePanel1.Top + ImagePanel1.Height, 150, 25);

    var Image2 = new TImage(WeBuilder);
    Image2.Parent = PSForm;
    Image2.Picture.LoadFromFile(Script.Path + "images\\" + frameImages[0]);
    Image2.Visible = true;
    Image2.Transparent = false;
	Image2.AutoSize = false;
	Image2.SetBounds(margin, margin + Label2.Top + Label2.Height, 64, 64);



	var Label3 = new TLabel(WeBuilder);
	Label3.Parent = PSForm;
	Label3.Anchors = akLeft + akTop;
	Label3.Caption = "Image Visibility method";
	Label3.SetBounds(margin, margin + Image2.Top + Image2.Height, 150, 25);

    var Image3 = new TImage(WeBuilder);
    Image3.Parent = PSForm;
    Image3.Picture.LoadFromFile(Script.Path + "images\\" + frameImages[0]);
    Image3.Visible = true;
    Image3.Transparent = false;
	Image3.AutoSize = false;
	Image3.SetBounds(margin, margin + Label3.Top + Label3.Height, 64, 64);

	AnimateSprite(Image1, 64, 100);

    AnimateCopy(Image2, frameImages, 100);

    AnimateVisibility(Image3, frameImages, 100);

    // Get result
   	var res = PSForm.Showmodal;

	// Cleanup
    if (spriteAnimTimer != null) delete spriteAnimTimer;
    if (copyAnimTimer != null) delete copyAnimTimer;
    if (visibleAnimTimer != null) delete visibleAnimTimer;
    if (PSForm != null) delete PSForm;
    spriteAnimTimer = null;
    visibleAnimTimer = null;
	spriteAnimObj = null;
	copyAnimTimer = null;
	copyAnimObj = null;
	PSForm = null;

}

/**
 * Initialize Sprite animation
 *
 * @param  object   imgObj  The TImage object to replace with anim sequence
 * @param  integer   step Width of each frame
 * @param  integer   duration duration The delay between images
 *
 * @return void
 */
function AnimateSprite(imgObj, step, duration) {
    // Global vars
    spriteAnimObj = imgObj;
	spriteAnimObj.Top = 0;
	spriteAnimObj.Left = 0;

    spriteAnimStep = step;

	spriteAnimTimer = new TTimer(WeBuilder);
	spriteAnimTimer.OnTimer = "AnimateSpriteTimer";
	spriteAnimTimer.Interval = duration;
	spriteAnimTimer.Enabled = true;
}

/**
 * Callback Timer function for updating sprite image position
 *
 * @return null
 */
function AnimateSpriteTimer() {
	var curPos = spriteAnimObj.Left - spriteAnimStep;
    if (curPos <= -spriteAnimObj.Width) curPos = 0;
    spriteAnimObj.Left = curPos;
}

/**
 * Load sequence of images for animation and starts timer callback
 *
 * @param  object/TImage   imageObj The TImage object to replace with anim sequence
 * @param  array           imageFiles Array [image1, image2, image3 etc.]
 * @param  integer         duration The delay between images
 *
 * @return void
 */
function AnimateVisibility(imgObj, imageFiles, duration) {

    var imgPath = Script.Path + "images\\";
    var imageCount = Length(imageFiles);

    SetLength(visibleAnimSeq, imageCount);

    for (var i=imageCount;i>0;i--) {
        img = new TImage(WeBuilder);
		img.Parent = imgObj.Parent;
		img.Transparent = imgObj.Transparent;
		img.AutoSize = imgObj.AutoSize;
		img.Visible = false;
        img.Picture.LoadFromFile(imgPath + imageFiles[i-1]);
		img.SetBounds(imgObj.Left, imgObj.Top, imgObj.Width, imgObj.Height)
        visibleAnimSeq[i-1] = img;
    }

	imgObj.Visible = false;

    // Global vars
    visibleAnimPointer = 0;

	visibleAnimTimer = new TTimer(WeBuilder);
	visibleAnimTimer.OnTimer = "AnimateVisibilityTimer";
	visibleAnimTimer.Interval = duration;
	visibleAnimTimer.Enabled = true;
}

/**
 * Callback Timer function for updating images in animation sequence
 *
 * @return null
 */
function AnimateVisibilityTimer() {
    var prev = visibleAnimSeq[visibleAnimPointer];
    visibleAnimPointer++;
    if (visibleAnimPointer >= Length(visibleAnimSeq)) visibleAnimPointer = 0;
    var img = visibleAnimSeq[visibleAnimPointer];
	img.Visible = true;
    prev.Visible = false;
}

/**
 * Load sequence of images for animation and starts timer callback
 *
 * @param  object/TImage   imageObj The TImage object to animate
 * @param  array           imageFiles Array [image1, image2, image3 etc.]
 * @param  integer         duration The delay between images
 *
 * @return void
 */
function AnimateCopy(imgObj, imageFiles, duration) {

    var imgdelay = duration;
    var imgPath = Script.Path + "images\\";
    var imageCount = Length(imageFiles);

    SetLength(copyAnimSeq, imageCount);

    for (var i=imageCount;i>0;i--) {
        img = new TImage(WeBuilder);
        img.Picture.LoadFromFile(imgPath + imageFiles[i-1]);
        copyAnimSeq[i-1] = img;
    }

    // Global vars
    copyAnimPointer = 0;
    copyAnimObj = imgObj;

	copyAnimTimer = new TTimer(WeBuilder);
	copyAnimTimer.OnTimer = "AnimateCopyTimer";
	copyAnimTimer.Interval = duration;
	copyAnimTimer.Enabled = true;
}

/**
 * Callback Timer function for copying images in animation sequence
 *
 * @return null
 */
function AnimateCopyTimer() {
    copyAnimPointer++;
    if (copyAnimPointer >= Length(copyAnimSeq)) copyAnimPointer = 0;
    var img = copyAnimSeq[copyAnimPointer];
    copyAnimObj.Picture = img.Picture;
}


/**
 * Cleanup of Global objects for when plugin is ending due to IDE closing
 * or plugin being disabled or uninstalled.
 *
 * @return void
 */
function OnExit() {
    if (imageAnimTimer != null) delete imageAnimTimer;
    if (visibleAnimTimer != null) delete visibleAnimTimer;
    if (copyAnimTimer != null) delete copyAnimTimer;
    if (PSForm != null) delete PSForm;
}

/*
 * Show info when plugin is installed.
 *
 * @return void
 */
function OnInstalled() {
  Alert("Animation Test 1.0 by Peter Klein installed sucessfully!");
}

Script.ConnectSignal("installed", "OnInstalled");

var bmp = new TBitmap, act;

LoadFileToBitmap(Script.Path + "animtest-icon.png", bmp);
act = Script.RegisterAction("", "AnimTest", "", "AnimTest");
Actions.SetIcon(act, bmp);

delete bmp;
